!c Description:
!c   §
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-06-04    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved


module interface_chk_singular
  interface
     
     subroutine chk_singular(temp, pres, property, mol, ssw)
       use prm_type, only: type_property
       real(8), intent(in)               :: temp
       real(8), intent(in)               :: pres
       real(8), intent(in)               :: mol(:)
       logical, intent(out), allocatable :: ssw(:) 
       type(type_property), intent(in)   :: property(:)
     end subroutine chk_singular
     
  end interface
end module interface_chk_singular



subroutine chk_singular(temp, pres, property, mol, ssw)
  use prm_type, only: type_property
  use prm_phys, only: pres_ref, gasr
  use interface_gibbs_energy
  use interface_name_cnd2gas
  use interface_name2num
  use interface_molfraction

  implicit none
  real(8), intent(in)               :: temp
  real(8), intent(in)               :: pres
  real(8), intent(in)               :: mol(:)
  logical, intent(out), allocatable :: ssw(:) 
  type(type_property), intent(in)   :: property(:)

  real(8), allocatable              :: mu0(:)
  real(8), allocatable              :: molfr(:)
  real(8), allocatable              :: factor(:)
  real(8)                           :: mu
  integer(8), allocatable           :: num(:)    
  integer(8)                        :: N
  integer(8)                        :: s, t, i
  character(80)                     :: name


!!!
!!!
!!!
  N = size(property, 1)
  if (allocated(ssw)) deallocate(ssw)
  allocate(ssw(N), num(N), factor(N))
  ssw = .true.
  num = 0 
  factor = 0.0d0
  
!!!
!!!ɸಽإݥƥ󥷥η׻
!!!
  call gibbs_energy(temp, pres, mol, property, mu0=mu0)


!!!
!!!η׻
!!!
  call molfraction(mol, property%phase, molfr)

  
!!!
!!!, б뵤ֹ
!!!  
  do s = 1, N
     if (property(s)%phase == 1) cycle
     call name_cnd2gas(property(s)%name, name)
     call name2num(name, property, num(s))
  end do

  
!!!
!!!絤Τȸ꤬¸ߤȽ
!!!
  cut3: do s = 1, N - 1
     if (property(s)%phase /= 1) cycle cut3 !ʳ̵
     mu = mu0(s) + gasr * temp * dlog(pres / pres_ref)
     
     cut3_1: do t = s + 1, N
        if (num(t) == 0) cycle cut3_1            !ȿβʪ̵

        if(s == num(t)) then   
           factor(t) = dexp((mu - mu0(t)) / (gasr * temp)) * molfr(s)
        end if
        
     end do cut3_1
  end do cut3

!  do s = 1, N
!     write(*,*) factor(s), molfr(s), factor(s) / molfr(s)
!  end do


  i = minloc(factor / mol, 1, factor > 0)
  ssw(i) = .false. 
  
  
  ! ssw  true ̵¥롼פˤʤΤ. 
  if (count(ssw) == N) stop
  
end subroutine chk_singular
