!c Description:
!c  ǮѲ뵤νͤ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_initmol
  interface
     
     subroutine initmol(emol, struct, mol, mol_ini)
       real(8), intent(in)                :: emol(:)   
       real(8), intent(in)                :: struct(:,:) 
       real(8), intent(in), optional      :: mol_ini(:)  
       real(8), intent(out), allocatable  :: mol(:)  
     end subroutine initmol
     
  end interface
end module interface_initmol




subroutine initmol(emol, struct, mol, mol_ini)
  use prm_common, only: min, int
  use interface_matrix_resolv
  
  implicit none
  real(8), intent(in)                :: emol(:)   
  real(8), intent(in)                :: struct(:,:) 
  real(8), intent(in), optional      :: mol_ini(:)  
  real(8), intent(out), allocatable  :: mol(:)  
  
  real(8), parameter        :: factor = 1.0d-1
  real(8), allocatable      :: A(:,:)
  real(8), allocatable      :: B(:)
  real(8), allocatable      :: emol_tmp(:)
  integer(8)                :: i, e
  integer(8)                :: N, M, num
  integer(8), allocatable   :: order(:)
  

  N = size(struct, 1)
  M = size(struct, 2)
  num = 1
  allocate(A(M, M), B(M), order(M), mol(N), emol_tmp(M))
  order = 0
  mol = 0.0d0
  
  
!!!
!!!κ
!!!
  do e = 1, M
     
     use: do i = 1, N
        if (struct(i, e) >= 1 .AND. .not. any(order == i)) then 
           A(num, :) = struct(i, :)
           order(e) = i
           exit use
        end if
     end do use
     
     num = num + 1
  end do

  !žֹѴ
  A = transpose(A)
  
  
  
!!!
!!!˻Ȥʤäؼ¸̤ŬͿ
!!!
  not_use: do i = 1, N
     if (any(order == i)) cycle not_use
     
     emol_tmp =  emol / struct(i, :) 
     num = minloc(emol_tmp, 1, emol_tmp > 0.0d0)

     mol(i) = (emol(num) * factor) / struct(i, num)

!     if (present(mol_ini) .AND. mol_ini(i) > mol(i)) then 
!        mol(i) = mol_ini(i)
!     end if
  end do not_use
  

!!!
!!!κ. ǥ뤫嵭Ϳʬθ̤򺹤
!!!
  do e = 1, M
     B(e) = emol(e) - dot_product(struct(:, e), mol)
  end do
  
!  where (B <= 0) 
!     B = int
!  end where
  
!!!
!!!󼰤, Ĥβؼ¸̤
!!!
  call matrix_resolv(A, B)
  do e = 1, M
     mol(order(e)) = B(e)
  end do
  
  if (minval(mol) < 0.0d0) stop
  
end subroutine Initmol
