!c Description:
!c   κ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_matrix_coeff
  interface
     
     subroutine matrix_coeff(mol, phase, struct, A)
       real(8), intent(in)               :: mol(:)      !ؼΥ
       real(8), intent(in)               :: struct(:,:) !ؼ˴ޤޤ븵ǿ
       real(8), intent(out), allocatable :: A(:,:)      !
       integer(8), intent(in)            :: phase(:)    !ؼֹ
     end subroutine matrix_coeff
     
  end interface
end module interface_matrix_coeff




subroutine matrix_coeff(mol, phase, struct, A)
  use interface_phase_pack
  
  implicit none
  real(8), intent(in)               :: mol(:)      !ؼΥ
  real(8), intent(in)               :: struct(:,:) !ؼ˴ޤޤ븵ǿ
  real(8), intent(out), allocatable :: A(:,:)      !
  integer(8), intent(in)            :: phase(:)    !ؼֹ
  
  integer(8), allocatable :: phase_tmp(:)
  integer(8)              :: smax        !¸ߤ벽ؼο
  integer(8)              :: pmax        !¸ߤο
  integer(8)              :: emax        !¸ߤ븵Ǥο
  integer(8)              :: e
  integer(8)              :: f
  integer(8)              :: p
  integer(8)              :: max
  integer(8)              :: min
  
  
!!!
!!!ѿν
!!!
  smax = size(struct, 1)
  emax = size(struct, 2)
  
  allocate(phase_tmp(smax))
  phase_tmp = phase
  call phase_pack(phase_tmp)
  pmax = maxval(phase_tmp)

  allocate(A(emax + pmax, emax + pmax))
  A = 0.0D0
  min = 1
  
!!!
!!!Ǥη׻
!!!
  do f = 1, emax
     do e = 1, emax
        A(f, e) = sum(struct(1:smax, e) * struct(1:smax, f) * mol(1:smax))
     end do
  end do
  
  do p = 1, pmax  
     !ֹ椫餢˴ޤޤʪǤϰϤ
     min = minloc(phase_tmp, 1, phase_tmp == p)
     max = min + count(phase_tmp == p) - 1 
     
     do e = 1, emax        
        A(emax + p, e) = sum(struct(min:max, e) * mol(min:max))     
     end do
     A(:, emax + p) = A(emax + p, :)
  end do

end subroutine matrix_coeff
